<?php

/**
 * This file is part of the Nette Framework (https://nette.org)
 * Copyright (c) 2004 David Grudl (https://davidgrudl.com)
 */

namespace Nette\Application;

use Nette;


/**
 * The bi-directional router.
 */
interface IRouter
{
	/** only matching route */
	const ONE_WAY = 0b0001;

	/** @deprecated */
	const SECURED = 0b0010;

	/**
	 * Maps HTTP request to a Request object.
	 * @return Request|null
	 */
	function match(Nette\Http\IRequest $httpRequest);

	/**
	 * Constructs absolute URL from Request object.
	 * @return string|null
	 */
	function constructUrl(Request $appRequest, Nette\Http\Url $refUrl);
}
